import { SVGCommand, TransformFunction } from "./SVGPathData";
import { TransformableSVG } from "./TransformableSVG";
export declare class SVGPathDataParser extends TransformableSVG {
    curCommand: any;
    state: number;
    curNumber: string;
    constructor();
    finish(commands?: SVGCommand[]): SVGCommand[];
    parse(str: string, commands?: SVGCommand[]): SVGCommand[];
    /**
     * Return a wrapper around this parser which applies the transformation on parsed commands.
     */
    transform(transform: TransformFunction): this;
    static readonly STATE_WSP: number;
    static readonly STATE_WSPS: number;
    static readonly STATE_COMMA: number;
    static readonly STATE_COMMAS: number;
    static readonly STATE_COMMAS_WSPS: number;
    static readonly STATE_NUMBER: number;
    static readonly STATE_NUMBER_DIGITS: number;
    static readonly STATE_NUMBER_INT: number;
    static readonly STATE_NUMBER_FLOAT: number;
    static readonly STATE_NUMBER_EXP: number;
    static readonly STATE_NUMBER_EXPSIGN: number;
    static readonly STATE_NUMBER_MASK: number;
    static readonly STATE_RELATIVE: number;
    static readonly STATE_CLOSE_PATH: number;
    static readonly STATE_MOVE_TO: number;
    static readonly STATE_LINE_TO: number;
    static readonly STATE_HORIZ_LINE_TO: number;
    static readonly STATE_VERT_LINE_TO: number;
    static readonly STATE_CURVE_TO: number;
    static readonly STATE_SMOOTH_CURVE_TO: number;
    static readonly STATE_QUAD_TO: number;
    static readonly STATE_SMOOTH_QUAD_TO: number;
    static readonly STATE_ARC: number;
    static readonly STATE_COMMANDS_MASK: number;
}
